#! /usr/bin/perl

use strict;

my $XML_SLIDE_TEMPLATE;
my $XML_SLIDESHOW_TEMPLATE;
my $CURRENT_SLIDE_NUMBER = 0;
my $SLIDE_TEXT = '';
my $SLIDESHOW_TEXT = '';
my $SLIDE_TITLE = '';
########################################################################

my $ODP_BULLET_POINT= <<"END_ODP_BULLET_POINT";
<text:list text:style-name="L2"><text:list-item><text:p text:style-name="P3"><text:span text:style-name="T1">__BULLET_TEXT_HERE__</text:span></text:p></text:list-item></text:list>
END_ODP_BULLET_POINT

my $ODP_SUB_BULLET_POINT= <<"END_ODP_SUB_BULLET_POINT";
<text:list text:style-name="L2"><text:list-item><text:list><text:list-item><text:p text:style-name="P4"><text:span text:style-name="T1">__SUB_BULLET_TEXT_HERE__</text:span></text:p></text:list-item></text:list></text:list-item></text:list>
END_ODP_SUB_BULLET_POINT

######################################################################

open(XML_SLIDE, "< $ARGV[1]") || die "could not open page template $ARGV[0]\n";

while (<XML_SLIDE>) {
    $XML_SLIDE_TEMPLATE .= $_;
}

close XML_SLIDE;

open(TEXT_OUTLINE, "< $ARGV[0]") || die "could not open text outline $ARGV[1]\n";

while (<TEXT_OUTLINE>) {
    chomp;
    if ($_ =~ m/^==(.*)==$/) {          # a new slide starts
	if ($CURRENT_SLIDE_NUMBER > 0) { #format the previous page
	    my $CURRENT_SLIDE = $XML_SLIDE_TEMPLATE;
	    $CURRENT_SLIDE =~ s/__SLIDE_NUMBER__/$CURRENT_SLIDE_NUMBER/g;
	    $CURRENT_SLIDE =~ s/__SLIDE_TITLE_GOES_HERE__/$SLIDE_TITLE/g;
	    $CURRENT_SLIDE =~ s/__SLIDE_TEXT_GOES_HERE__/$SLIDE_TEXT/;
	    $SLIDESHOW_TEXT .= $CURRENT_SLIDE;
	    $CURRENT_SLIDE = '';
	    $SLIDE_TEXT = '';
	}
	$SLIDE_TITLE = $1;
	print STDERR "$CURRENT_SLIDE_NUMBER TITLE: $SLIDE_TITLE;\n";
	$CURRENT_SLIDE_NUMBER++;
    }
	
    if ($_ =~ m/^-(.*)$/) { # bullet point
	my $CURRENT_BULLET_TEXT = $1;
	my $CURRENT_BULLET_POINT = $ODP_BULLET_POINT;
	$CURRENT_BULLET_POINT =~ s/__BULLET_TEXT_HERE__/$CURRENT_BULLET_TEXT/;
	$SLIDE_TEXT .= $CURRENT_BULLET_POINT;
    }
	
    if ($_ =~ m/^ -(.*)$/) { # sub-bullet point
	my $CURRENT_SUB_BULLET_TEXT = $1;
	my $CURRENT_SUB_BULLET_POINT = $ODP_SUB_BULLET_POINT;
	$CURRENT_SUB_BULLET_POINT =~ s/__SUB_BULLET_TEXT_HERE__/$CURRENT_SUB_BULLET_TEXT/;
	$SLIDE_TEXT .= $CURRENT_SUB_BULLET_POINT;
    }
}
close TEXT_OUTLINE;

my $LAST_SLIDE   = $XML_SLIDE_TEMPLATE;
$LAST_SLIDE      =~ s/__SLIDE_NUMBER__/$CURRENT_SLIDE_NUMBER/g;
$LAST_SLIDE      =~ s/__SLIDE_TITLE_GOES_HERE__/$SLIDE_TITLE/g;
$LAST_SLIDE      =~ s/__SLIDE_TEXT_GOES_HERE__/$SLIDE_TEXT/;
$SLIDESHOW_TEXT .= $LAST_SLIDE;

undef $/;
open(XML_TEMPLATE_FILE, "< $ARGV[2]") || die "could not open content XML template $ARGV[1]\n";
my $XML_TEMPLATE = <XML_TEMPLATE_FILE>;
close XML_TEMPLATE_FILE;

$XML_TEMPLATE =~ s/__MY_SLIDES_GO_HERE__/$SLIDESHOW_TEXT/;
print $XML_TEMPLATE;
exit;
